//---------------------------------------------------------------------------
//AnalogClock Sample Program
//---------------------------------------------------------------------------
#include <vcl.h>
#include <Math.hpp>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
#define	Min(a,b)	(((a) < (b)) ? (a) : (b))
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	mMargin = 10;		//]TCY
	Timer1Timer(0);		//Jn
}
//---------------------------------------------------------------------------
//^C}Cxg
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	Timer1->Enabled = false;

	//݂̎擾
	Word hour, min, sec, msec;
	DecodeTime(Time(), hour, min, sec, msec);

	Caption = Caption.sprintf(" %02d:%02d:%02d", hour, min, sec);

	//wi̕`
	DrawBase();

	//Zj
	hour = hour % 12 * 5;
	int angle = hour * 6 + min / 2;
	DrawNeedle(angle, 0);

	//j
	angle = min * 6;
	DrawNeedle(angle, 1);

	//bj
	angle = sec * 6;
	DrawNeedle(angle, 2);

	Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DrawBase(void)
{
	//`\̈̍W
	int rect_left = Image1->Canvas->ClipRect.Left;
	int rect_top = Image1->Canvas->ClipRect.Top;
	int rect_width = Image1->Canvas->ClipRect.Right;
	int rect_height = Image1->Canvas->ClipRect.Bottom;

	//~̕`W
	int draw_left = rect_left + mMargin;				//
	int draw_top = rect_top + mMargin;					//
	int diameter = Min(rect_width, rect_height);		//a
	int draw_to = diameter - mMargin;					//E

	//~`
	Image1->Canvas->Brush->Color = clSkyBlue;			//wiFF
	Image1->Canvas->Pen->Color = clBlack;				//̐FF
	Image1->Canvas->Ellipse(draw_left, draw_top, draw_to, draw_to);

	//ڐ`
	int radius = diameter / 2;		//a
	int center = radius;
	int line_len;
	Extended sin_x, cos_y;
	for (int angle = 0; angle < 360; angle += 30)
	{
		//wpxSINlCOSl擾
		SinCos(DegToRad(angle), sin_x, cos_y);

		if ((angle % 90) == 0)
		{
			//PTɒڐ`
			line_len = mMargin;
		} else {
			//TɒZڐ`
			line_len = mMargin / 2;
		}

		//`Jnʒu
		int move_x = center + sin_x * (radius - mMargin - line_len);
		int move_y = center - cos_y * (radius - mMargin - line_len);
		Image1->Canvas->MoveTo(move_x, move_y);

		//`Iʒu܂Ő`
		int line_x = center + sin_x * (radius - mMargin);
		int line_y = center - cos_y * (radius - mMargin);
		Image1->Canvas->LineTo(line_x, line_y);
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DrawNeedle(int angle, int mode)
{
	//`\̈̍W
	int rect_width = Image1->Canvas->ClipRect.Right;
	int rect_height = Image1->Canvas->ClipRect.Bottom;

	//~̕`W
	int diameter = Min(rect_width, rect_height);	//a
	int radius = diameter / 2;						//a

	int line_len;
	switch (mode)
	{
	  case 0:	//Zj
		Image1->Canvas->Pen->Color = clBlack;
		line_len = radius - mMargin * 6;
		break;
	  case 1:	//j
		Image1->Canvas->Pen->Color = clBlack;
		line_len = radius - mMargin * 3;
		break;
	  case 2:	//bj
		Image1->Canvas->Pen->Color = clRed;
		line_len = radius - mMargin * 2;
		break;
	}

	//wpxSINlCOSl擾
	Extended sin_x, cos_y;
	SinCos(DegToRad(angle), sin_x, cos_y);

	//`Jnʒu
	int center = radius;
	Image1->Canvas->MoveTo(center, center);

	//`Iʒu܂Ő`
	int line_x = center + sin_x * line_len;
	int line_y = center - cos_y * line_len;
	Image1->Canvas->LineTo(line_x, line_y);
}
//---------------------------------------------------------------------------

